/*
 * Copyright (C) 2010 David Arkell.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gwtorbit.client.widgets;

import java.util.HashSet;
import java.util.Set;

import com.google.gwt.dom.client.Document;
import com.google.gwt.event.dom.client.DomEvent;
import com.google.gwt.event.dom.client.KeyCodes;
import com.google.gwt.event.dom.client.KeyPressEvent;
import com.google.gwt.event.dom.client.KeyPressHandler;
import com.google.gwt.user.client.ui.FocusPanel;
import com.google.gwt.user.client.ui.Widget;

public class BFocusPanel extends FocusPanel {

	public static Set<Integer> keyPressToClick = new HashSet<Integer>();

	{
		keyPressToClick.add(KeyCodes.KEY_ENTER);
		keyPressToClick.add((int) ' ');
	}

	public BFocusPanel() {
		this.addKeyPressHandler(new KeyPressHandler() {
			public void onKeyPress(KeyPressEvent event) {
				if (keyPressToClick.contains(event.getNativeEvent().getKeyCode())) {
					DomEvent.fireNativeEvent(Document.get().createClickEvent(0, 0, 0, 0, 0,
							event.isControlKeyDown(), event.isAltKeyDown(), event.isShiftKeyDown(),
							event.isMetaKeyDown()), BFocusPanel.this);
				}
			}
		});
	}

	public BFocusPanel(Widget child) {
		this();
		setWidget(child);
	}

}
