/*
 * Copyright (C) 2010 David Arkell.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gwtorbit.client.widgets;

import java.util.Iterator;

import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.user.client.ui.HasWidgets;
import com.google.gwt.user.client.ui.Widget;
import com.gwtorbit.client.model.UiData;
import com.gwtorbit.client.model.UiDataDisplay;
import com.gwtorbit.client.model.UiErrors;

public class FormUiListOfRadioButtons extends FormAbstractRowWithUiErrorDisplay implements
		UiDataDisplay, HasWidgets, HasClickHandlers {

	private UiListOfRadioButtons field;

	public FormUiListOfRadioButtons() {
		field = new UiListOfRadioButtons();
		setFieldWidget(field);
	}

	public void setMandatory(boolean mandatory) {
		super.setMandatory(mandatory);
		field.setMandatory(mandatory);
	}

	public String getDataName() {
		return field.getDataName();
	}

	public void setDataName(String dataName) {
		super.setDataName(dataName);
		field.setDataName(dataName);
	}

	public void displayErrors(UiErrors errors, String errorPrefix) {
		super.displayErrors(errors, errorPrefix);
		field.displayErrors(errors, errorPrefix);
	}

	public void displayData(UiData uiData) {
		field.displayData(uiData);
	}

	public void getData(UiData uiData, UiErrors errors, String errorPrefix) {
		field.getData(uiData, errors, errorPrefix);
	}

	public void clearErrors() {
		super.clearErrors();
		field.clearErrors();
	}

	public void clearData() {
		field.clearData();
	}

	public boolean getIgnore() {
		return field.getIgnore();
	}

	public void setIgnore(boolean ignore) {
		field.setIgnore(ignore);
	}

	public void add(Widget w) {
		field.add(w);
	}

	public void clear() {
		field.clear();
	}

	public Iterator<Widget> iterator() {
		return field.iterator();
	}

	public boolean remove(Widget w) {
		return field.remove(w);
	}

	public void addOption(String label, Object value) {
		field.addOption(label, value);
	}

	public Object getFieldData() {
		return field.getData();
	}

	public HandlerRegistration addClickHandler(ClickHandler handler) {
		return field.addClickHandler(handler);
	}
}
