/*
 * Copyright (C) 2010 David Arkell.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gwtorbit.client.widgets;

import com.google.gwt.user.client.ui.Label;
import com.gwtorbit.client.mvp.ClientResourceBundle;

public class LLabel extends Label {

	public LLabel() {

	}

	public LLabel(String key) {
		this();
		setKey(key);
	}

	public void setKey(String key) {
		this.key = key;
		displayText();
	}

	private void displayText() {
		if (phraseKey == null) {
			setText(ClientResourceBundle.getString(keyPrefix + key));
		} else {
			setText(ClientResourceBundle.getString(phraseKey, ClientResourceBundle
					.getString(keyPrefix + key)));
		}
	}

	private String key;

	private String keyPrefix = "";

	private String phraseKey;

	public String getKey() {
		return key;
	}

	public void setKeyPrefix(String keyPrefix) {
		this.keyPrefix = keyPrefix;
	}

	public String getKeyPrefix() {
		return keyPrefix;
	}

	public void setPhraseKey(String phraseKey) {
		this.phraseKey = phraseKey;
		if (key != null) {
			displayText();
		}
	}

	public String getPhraseKey() {
		return phraseKey;
	}

}
