/*
 * Copyright (C) 2010 David Arkell.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gwtorbit.client.widgets;

import com.google.gwt.user.client.ui.Label;
import com.gwtorbit.client.mvp.ClientResourceBundle;

public class LLabelDecimal extends Label {

	public LLabelDecimal() {

	}

	public LLabelDecimal(Integer value) {
		this();
		setValue(value);
	}

	private Integer value;

	private String phraseKey;

	public void setValue(Integer value) {
		this.value = value;
		displayValue();
	}

	private void displayValue() {
		if (phraseKey == null) {
			setText(ClientResourceBundle.integerFormat.format(value));
		} else {
			setText(ClientResourceBundle.getString(phraseKey, ClientResourceBundle.integerFormat
					.format(value)));
		}
	}

	public Integer getValue() {
		return value;
	}

	public void setPhraseKey(String phraseKey) {
		this.phraseKey = phraseKey;
		if (value != null) {
			displayValue();
		}
	}

	public String getPhraseKey() {
		return phraseKey;
	}

}
